Index: uspace/app/calculator/calculator.c
===================================================================
--- uspace/app/calculator/calculator.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/calculator/calculator.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2016 Martin Decky
  * All rights reserved.
@@ -37,4 +37,5 @@
  */
 
+#include <clipboard.h>
 #include <ctype.h>
 #include <io/kbd_event.h>
@@ -45,4 +46,7 @@
 #include <ui/entry.h>
 #include <ui/fixed.h>
+#include <ui/menubar.h>
+#include <ui/menu.h>
+#include <ui/menuentry.h>
 #include <ui/pbutton.h>
 #include <ui/ui.h>
@@ -95,6 +99,16 @@
 } stack_item_t;
 
+/** Dimensions. Most of this should not be needed with auto layout */
+typedef struct {
+	gfx_rect_t menubar_rect;
+	gfx_rect_t entry_rect;
+	gfx_coord2_t btn_orig;
+	gfx_coord2_t btn_stride;
+	gfx_coord2_t btn_dim;
+} calc_geom_t;
+
 typedef struct {
 	ui_t *ui;
+	ui_resource_t *ui_res;
 	ui_pbutton_t *btn_eval;
 	ui_pbutton_t *btn_clear;
@@ -113,5 +127,13 @@
 	ui_pbutton_t *btn_8;
 	ui_pbutton_t *btn_9;
+	ui_menu_bar_t *menubar;
+	calc_geom_t geom;
 } calc_t;
+
+static void display_update(void);
+
+static void calc_file_exit(ui_menu_entry_t *, void *);
+static void calc_edit_copy(ui_menu_entry_t *, void *);
+static void calc_edit_paste(ui_menu_entry_t *, void *);
 
 static void calc_pb_clicked(ui_pbutton_t *, void *);
@@ -138,4 +160,7 @@
 	.kbd = wnd_kbd_event
 };
+
+static char *expr = NULL;
+static ui_entry_t *display;
 
 /** Window close request
@@ -160,4 +185,17 @@
 {
 	calc_t *calc = (calc_t *) arg;
+
+	if (event->type == KEY_PRESS && (event->mods & KM_CTRL) != 0) {
+		switch (event->key) {
+		case KC_C:
+			calc_edit_copy(NULL, calc);
+			break;
+		case KC_V:
+			calc_edit_paste(NULL, calc);
+			break;
+		default:
+			break;
+		}
+	}
 
 	switch (event->key) {
@@ -264,6 +302,65 @@
 }
 
-static char *expr = NULL;
-static ui_entry_t *display;
+/** File / Exit menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (calc_t *)
+ */
+static void calc_file_exit(ui_menu_entry_t *mentry, void *arg)
+{
+	calc_t *calc = (calc_t *) arg;
+
+	ui_quit(calc->ui);
+}
+
+/** Edit / Copy menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (calc_t *)
+ */
+static void calc_edit_copy(ui_menu_entry_t *mentry, void *arg)
+{
+	const char *str;
+
+	(void) arg;
+	str = (expr != NULL) ? expr : NULL_DISPLAY;
+
+	(void) clipboard_put_str(str);
+}
+
+/** Edit / Paste menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (calc_t *)
+ */
+static void calc_edit_paste(ui_menu_entry_t *mentry, void *arg)
+{
+	char *str;
+	char *old;
+	char *cp;
+	errno_t rc;
+
+	(void) arg;
+
+	rc = clipboard_get_str(&str);
+	if (rc != EOK)
+		return;
+
+	/* Make sure string only contains allowed characters */
+	cp = str;
+	while (*cp != '\0') {
+		if (!isdigit(*cp) && *cp != '+' && *cp != '-' &&
+		    *cp != '*' && *cp != '/')
+			return;
+		++cp;
+	}
+
+	/* Update expression */
+	old = expr;
+	expr = str;
+	free(old);
+
+	display_update();
+}
 
 static bool is_digit(char c)
@@ -650,5 +747,5 @@
 }
 
-static errno_t calc_button_create(ui_resource_t *ui_res, ui_fixed_t *fixed,
+static errno_t calc_button_create(calc_t *calc, ui_fixed_t *fixed,
     int x, int y, const char *text, ui_pbutton_cb_t *cb, void *arg,
     ui_pbutton_t **rbutton)
@@ -658,5 +755,5 @@
 	errno_t rc;
 
-	rc = ui_pbutton_create(ui_res, text, &pb);
+	rc = ui_pbutton_create(calc->ui_res, text, &pb);
 	if (rc != EOK) {
 		printf("Error creating button.\n");
@@ -666,8 +763,8 @@
 	ui_pbutton_set_cb(pb, cb, arg);
 
-	rect.p0.x = 10 + 60 * x;
-	rect.p0.y = 90 + 45 * y;
-	rect.p1.x = 60 + 60 * x;
-	rect.p1.y = 125 + 45 * y;
+	rect.p0.x = calc->geom.btn_orig.x + calc->geom.btn_stride.x * x;
+	rect.p0.y = calc->geom.btn_orig.y + calc->geom.btn_stride.y * y;
+	rect.p1.x = rect.p0.x + calc->geom.btn_dim.x;
+	rect.p1.y = rect.p0.y + calc->geom.btn_dim.y;
 	ui_pbutton_set_rect(pb, &rect);
 
@@ -696,5 +793,9 @@
 	ui_wnd_params_t params;
 	ui_window_t *window;
-	gfx_rect_t rect;
+	ui_menu_t *mfile;
+	ui_menu_entry_t *mexit;
+	ui_menu_t *medit;
+	ui_menu_entry_t *mcopy;
+	ui_menu_entry_t *mpaste;
 	calc_t calc;
 	errno_t rc;
@@ -729,6 +830,42 @@
 	params.rect.p0.x = 0;
 	params.rect.p0.y = 0;
-	params.rect.p1.x = 250;
-	params.rect.p1.y = 270;
+
+	if (ui_is_textmode(ui)) {
+		params.rect.p1.x = 38;
+		params.rect.p1.y = 19;
+
+		calc.geom.menubar_rect.p0.x = 1;
+		calc.geom.menubar_rect.p0.y = 2;
+		calc.geom.menubar_rect.p1.x = params.rect.p1.x - 1;
+		calc.geom.menubar_rect.p1.y = 3;
+		calc.geom.entry_rect.p0.x = 4;
+		calc.geom.entry_rect.p0.y = 4;
+		calc.geom.entry_rect.p1.x = 34;
+		calc.geom.entry_rect.p1.y = 5;
+		calc.geom.btn_orig.x = 4;
+		calc.geom.btn_orig.y = 6;
+		calc.geom.btn_dim.x = 6;
+		calc.geom.btn_dim.y = 2;
+		calc.geom.btn_stride.x = 8;
+		calc.geom.btn_stride.y = 3;
+	} else {
+		params.rect.p1.x = 250;
+		params.rect.p1.y = 270;
+
+		calc.geom.menubar_rect.p0.x = 4;
+		calc.geom.menubar_rect.p0.y = 30;
+		calc.geom.menubar_rect.p1.x = params.rect.p1.x - 4;
+		calc.geom.menubar_rect.p1.y = 52;
+		calc.geom.entry_rect.p0.x = 10;
+		calc.geom.entry_rect.p0.y = 51;
+		calc.geom.entry_rect.p1.x = 240;
+		calc.geom.entry_rect.p1.y = 76;
+		calc.geom.btn_orig.x = 10;
+		calc.geom.btn_orig.y = 90;
+		calc.geom.btn_dim.x = 50;
+		calc.geom.btn_dim.y = 35;
+		calc.geom.btn_stride.x = 60;
+		calc.geom.btn_stride.y = 45;
+	}
 
 	rc = ui_window_create(ui, &params, &window);
@@ -742,4 +879,5 @@
 
 	ui_res = ui_window_get_res(window);
+	calc.ui_res = ui_res;
 
 	rc = ui_fixed_create(&fixed);
@@ -749,5 +887,55 @@
 	}
 
-	rc = ui_entry_create(ui_res, NULL_DISPLAY, &display);
+	rc = ui_menu_bar_create(ui, window, &calc.menubar);
+	if (rc != EOK) {
+		printf("Error creating menu bar.\n");
+		return rc;
+	}
+
+	rc = ui_menu_create(calc.menubar, "File", &mfile);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(mfile, "Exit", "Alt-F4", &mexit);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mexit, calc_file_exit, (void *) &calc);
+
+	rc = ui_menu_create(calc.menubar, "Edit", &medit);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(medit, "Copy", "Ctrl-C", &mcopy);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mcopy, calc_edit_copy, (void *) &calc);
+
+	rc = ui_menu_entry_create(medit, "Paste", "Ctrl-V", &mpaste);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mpaste, calc_edit_paste, (void *) &calc);
+
+	ui_menu_bar_set_rect(calc.menubar, &calc.geom.menubar_rect);
+
+	rc = ui_fixed_add(fixed, ui_menu_bar_ctl(calc.menubar));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_entry_create(window, NULL_DISPLAY, &display);
 	if (rc != EOK) {
 		printf("Error creating text lentry.\n");
@@ -755,10 +943,7 @@
 	}
 
-	rect.p0.x = 15;
-	rect.p0.y = 45;
-	rect.p1.x = 235;
-	rect.p1.y = 70;
-	ui_entry_set_rect(display, &rect);
+	ui_entry_set_rect(display, &calc.geom.entry_rect);
 	ui_entry_set_halign(display, gfx_halign_right);
+	ui_entry_set_read_only(display, true);
 
 	rc = ui_fixed_add(fixed, ui_entry_ctl(display));
@@ -768,80 +953,80 @@
 	}
 
-	rc = calc_button_create(ui_res, fixed, 0, 0, "7", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 0, 0, "7", &calc_pbutton_cb,
 	    (void *) "7", &calc.btn_7);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 1, 0, "8", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 1, 0, "8", &calc_pbutton_cb,
 	    (void *) "8", &calc.btn_8);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 2, 0, "9", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 2, 0, "9", &calc_pbutton_cb,
 	    (void *) "9", &calc.btn_9);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 3, 0, "/", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 3, 0, "/", &calc_pbutton_cb,
 	    (void *) "/", &calc.btn_div);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 0, 1, "4", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 0, 1, "4", &calc_pbutton_cb,
 	    (void *) "4", &calc.btn_4);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 1, 1, "5", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 1, 1, "5", &calc_pbutton_cb,
 	    (void *) "5", &calc.btn_5);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 2, 1, "6", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 2, 1, "6", &calc_pbutton_cb,
 	    (void *) "6", &calc.btn_6);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 3, 1, "*", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 3, 1, "*", &calc_pbutton_cb,
 	    (void *) "*", &calc.btn_mul);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 0, 2, "1", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 0, 2, "1", &calc_pbutton_cb,
 	    (void *) "1", &calc.btn_1);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 1, 2, "2", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 1, 2, "2", &calc_pbutton_cb,
 	    (void *) "2", &calc.btn_2);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 2, 2, "3", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 2, 2, "3", &calc_pbutton_cb,
 	    (void *) "3", &calc.btn_3);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 3, 2, "-", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 3, 2, "-", &calc_pbutton_cb,
 	    (void *) "-", &calc.btn_sub);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 0, 3, "0", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 0, 3, "0", &calc_pbutton_cb,
 	    (void *) "0", &calc.btn_0);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 1, 3, "C", &calc_clear_cb,
+	rc = calc_button_create(&calc, fixed, 1, 3, "C", &calc_clear_cb,
 	    (void *) "C", &calc.btn_clear);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 2, 3, "=", &calc_eval_cb,
+	rc = calc_button_create(&calc, fixed, 2, 3, "=", &calc_eval_cb,
 	    (void *) "=", &calc.btn_eval);
 	if (rc != EOK)
 		return rc;
 
-	rc = calc_button_create(ui_res, fixed, 3, 3, "+", &calc_pbutton_cb,
+	rc = calc_button_create(&calc, fixed, 3, 3, "+", &calc_pbutton_cb,
 	    (void *) "+", &calc.btn_add);
 	if (rc != EOK)
Index: uspace/app/devctl/meson.build
===================================================================
--- uspace/app/devctl/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/devctl/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'device' ]
 src = files('devctl.c')
Index: uspace/app/dnscfg/meson.build
===================================================================
--- uspace/app/dnscfg/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/dnscfg/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2013 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('dnscfg.c')
Index: uspace/app/dnsres/meson.build
===================================================================
--- uspace/app/dnsres/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/dnsres/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2013 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('dnsres.c')
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/edit/edit.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -251,5 +251,8 @@
 
 	while (!done) {
-		console_get_event(con, &ev);
+		rc = console_get_event(con, &ev);
+		if (rc != EOK)
+			break;
+
 		pane.rflags = 0;
 
@@ -634,4 +637,5 @@
 	int nc;
 	bool done;
+	errno_t rc;
 
 	asprintf(&str, "%s: %s", prompt, init_value);
@@ -648,5 +652,7 @@
 
 	while (!done) {
-		console_get_event(con, &ev);
+		rc = console_get_event(con, &ev);
+		if (rc != EOK)
+			return NULL;
 
 		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
Index: uspace/app/fdisk/meson.build
===================================================================
--- uspace/app/fdisk/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/fdisk/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'clui', 'fdisk' ]
+deps = [ 'clui', 'device', 'fdisk' ]
 src = files('fdisk.c')
Index: uspace/app/fontedit/fontedit.c
===================================================================
--- uspace/app/fontedit/fontedit.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/fontedit/fontedit.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -446,9 +446,10 @@
  * @param fedit Font editor
  * @param x Starting X coordinate
- * @Param y Starting Y coordinate
+ * @param y Starting Y coordinate
+ * @param color Color
  * @param str String
  */
 static errno_t font_edit_paint_preview_str(font_edit_t *fedit,
-    gfx_coord_t x, gfx_coord_t y, const char *str)
+    gfx_coord_t x, gfx_coord_t y, gfx_color_t *color, const char *str)
 {
 	gfx_text_fmt_t fmt;
@@ -456,4 +457,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = color;
 
 	pos.x = x;
@@ -480,25 +482,25 @@
 		goto error;
 
-	rc = font_edit_paint_preview_str(fedit, 20, 20,
+	rc = font_edit_paint_preview_str(fedit, 20, 20, color,
 	    "ABCDEFGHIJKLMNOPQRSTUVWXYZ");
 	if (rc != EOK)
 		goto error;
 
-	rc = font_edit_paint_preview_str(fedit, 20, 40,
+	rc = font_edit_paint_preview_str(fedit, 20, 40, color,
 	    "THE QUICK BROWN FOX JUMPS OVER THE LAZY DOG");
 	if (rc != EOK)
 		goto error;
 
-	rc = font_edit_paint_preview_str(fedit, 20, 60,
+	rc = font_edit_paint_preview_str(fedit, 20, 60, color,
 	    "abcdefghijklmnopqrstuvwxyz");
 	if (rc != EOK)
 		goto error;
 
-	rc = font_edit_paint_preview_str(fedit, 20, 80,
+	rc = font_edit_paint_preview_str(fedit, 20, 80, color,
 	    "the quick brown fox jumps over the lazy dog");
 	if (rc != EOK)
 		goto error;
 
-	rc = font_edit_paint_preview_str(fedit, 20, 100,
+	rc = font_edit_paint_preview_str(fedit, 20, 100, color,
 	    "0123456789,./<>?;'\\:\"|[]{}`~!@#$%^&*()-_=+");
 	if (rc != EOK)
Index: uspace/app/gfxdemo/gfxdemo.c
===================================================================
--- uspace/app/gfxdemo/gfxdemo.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/gfxdemo/gfxdemo.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -69,4 +69,7 @@
 
 static bool quit = false;
+static gfx_typeface_t *tface;
+static gfx_font_t *font;
+static gfx_coord_t vpad;
 
 /** Clear screen.
@@ -107,9 +110,153 @@
 }
 
-/** Run rectangle demo on a graphic context.
+/** Initialize demo font.
  *
  * @param gc Graphic context
  * @param w Width
  * @param h Height
+ * @return EOK on success or an error code
+ */
+static errno_t demo_font_init(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_font_info_t *finfo;
+	errno_t rc;
+
+	if (quit)
+		return EOK;
+
+	/* XXX Crude way of detecting text mode */
+	if (w < 256) {
+		/* Create dummy font for text mode */
+		rc = gfx_typeface_create(gc, &tface);
+		if (rc != EOK) {
+			printf("Error creating typeface\n");
+			goto error;
+		}
+
+		rc = gfx_font_create_textmode(tface, &font);
+		if (rc != EOK) {
+			printf("Error creating font\n");
+			goto error;
+		}
+
+		vpad = 0;
+	} else {
+		/* Load font */
+		rc = gfx_typeface_open(gc, "/data/font/helena.tpf", &tface);
+		if (rc != EOK) {
+			printf("Error opening typeface\n");
+			goto error;
+		}
+
+		finfo = gfx_typeface_first_font(tface);
+		if (finfo == NULL) {
+			printf("Typeface contains no font.\n");
+			rc = ENOENT;
+			goto error;
+		}
+
+		rc = gfx_font_open(finfo, &font);
+		if (rc != EOK) {
+			printf("Error opening font.\n");
+			goto error;
+		}
+
+		vpad = 5;
+	}
+
+	return EOK;
+error:
+	if (tface != NULL)
+		gfx_typeface_destroy(tface);
+	return rc;
+}
+
+/** Finalize demo font. */
+static void demo_font_fini(void)
+{
+	if (font == NULL)
+		return;
+
+	gfx_font_close(font);
+	font = NULL;
+
+	gfx_typeface_destroy(tface);
+	tface = NULL;
+}
+
+/** Start a new demo screen.
+ *
+ * Clear the screen, display a status line and set up clipping.
+ *
+ * @param gc Graphic context
+ * @param w Width
+ * @param h Height
+ * @param text Demo screen description
+ * @return EOK on success or an error code
+ */
+static errno_t demo_begin(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h,
+    const char *text)
+{
+	gfx_text_fmt_t fmt;
+	gfx_font_metrics_t metrics;
+	gfx_coord2_t pos;
+	gfx_color_t *color;
+	gfx_rect_t rect;
+	gfx_coord_t height;
+	errno_t rc;
+
+	rc = gfx_set_clip_rect(gc, NULL);
+	if (rc != EOK)
+		return rc;
+
+	rc = clear_scr(gc, w, h);
+	if (rc != EOK)
+		return rc;
+
+	if (font != NULL) {
+		rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &color);
+		if (rc != EOK)
+			goto error;
+
+		gfx_text_fmt_init(&fmt);
+		fmt.color = color;
+		fmt.halign = gfx_halign_center;
+		fmt.valign = gfx_valign_bottom;
+
+		pos.x = w / 2;
+		pos.y = h - 1;
+		rc = gfx_puttext(font, &pos, &fmt, text);
+		if (rc != EOK) {
+			printf("Error rendering text.\n");
+			gfx_color_delete(color);
+			goto error;
+		}
+
+		gfx_color_delete(color);
+
+		gfx_font_get_metrics(font, &metrics);
+		height = metrics.ascent + metrics.descent + 1;
+	} else {
+		height = 0;
+	}
+
+	rect.p0.x = 0;
+	rect.p0.y = 0;
+	rect.p1.x = w;
+	rect.p1.y = h - height - vpad;
+	rc = gfx_set_clip_rect(gc, &rect);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Run rectangle demo on a graphic context.
+ *
+ * @param gc Graphic context
+ * @param w Width
+ * @param h Height
  */
 static errno_t demo_rects(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
@@ -123,5 +270,5 @@
 		return EOK;
 
-	rc = clear_scr(gc, w, h);
+	rc = demo_begin(gc, w, h, "Rectangle rendering");
 	if (rc != EOK)
 		return rc;
@@ -185,5 +332,5 @@
 		for (j = 0; j < h; j++) {
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    PIXEL(255, (i % 30) < 3 ? 255 : 0,
+			    PIXEL(0, (i % 30) < 3 ? 255 : 0,
 			    (j % 30) < 3 ? 255 : 0, i / 2));
 		}
@@ -221,5 +368,5 @@
 			k = i * i + j * j;
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    PIXEL(255, k, k, k));
+			    PIXEL(0, k, k, k));
 		}
 	}
@@ -256,5 +403,5 @@
 			k = i * i + j * j;
 			pixelmap_put_pixel(&pixelmap, i, j,
-			    k < w * w / 2 ? PIXEL(255, 0, 255, 0) :
+			    k < w * w / 2 ? PIXEL(0, 0, 255, 0) :
 			    PIXEL(0, 255, 0, 255));
 		}
@@ -282,5 +429,5 @@
 		return EOK;
 
-	rc = clear_scr(gc, w, h);
+	rc = demo_begin(gc, w, h, "Bitmap rendering without offset");
 	if (rc != EOK)
 		return rc;
@@ -345,5 +492,5 @@
 		return EOK;
 
-	rc = clear_scr(gc, w, h);
+	rc = demo_begin(gc, w, h, "Bitmap rendering with offset");
 	if (rc != EOK)
 		return rc;
@@ -404,5 +551,5 @@
 		return EOK;
 
-	rc = clear_scr(gc, w, h);
+	rc = demo_begin(gc, w, h, "Bitmap rendering with color key");
 	if (rc != EOK)
 		return rc;
@@ -458,7 +605,4 @@
 	gfx_color_t *color = NULL;
 	gfx_rect_t rect;
-	gfx_typeface_t *tface = NULL;
-	gfx_font_info_t *finfo;
-	gfx_font_t *font = NULL;
 	gfx_coord2_t pos;
 	gfx_text_fmt_t fmt;
@@ -469,24 +613,5 @@
 		return EOK;
 
-	rc = gfx_typeface_open(gc, "/data/font/helena.tpf", &tface);
-	if (rc != EOK) {
-		printf("Error opening typeface\n");
-		goto error;
-	}
-
-	finfo = gfx_typeface_first_font(tface);
-	if (finfo == NULL) {
-		printf("Typeface contains no font.\n");
-		rc = ENOENT;
-		goto error;
-	}
-
-	rc = gfx_font_open(finfo, &font);
-	if (rc != EOK) {
-		printf("Error opening font.\n");
-		goto error;
-	}
-
-	rc = clear_scr(gc, w, h);
+	rc = demo_begin(gc, w, h, "Text rendering");
 	if (rc != EOK)
 		goto error;
@@ -525,7 +650,7 @@
 
 	rect.p0.x = w / 20;
-	rect.p0.y = 2 * h / 15;
+	rect.p0.y = 1 * h / 15;
 	rect.p1.x = w - w / 20;
-	rect.p1.y = 5 * h / 15;
+	rect.p1.y = 4 * h / 15;
 
 	rc = gfx_fill_rect(gc, &rect);
@@ -539,9 +664,6 @@
 		goto error;
 
-	rc = gfx_set_color(gc, color);
-	if (rc != EOK)
-		goto error;
-
 	gfx_text_fmt_init(&fmt);
+	fmt.color = color;
 
 	pos.x = rect.p0.x;
@@ -623,10 +745,8 @@
 			goto error;
 
-		rc = gfx_set_color(gc, color);
-		if (rc != EOK)
-			goto error;
+		fmt.color = color;
 
 		pos.x = w / 20;
-		pos.y = (7 + i) * h / 15;
+		pos.y = (6 + i) * h / 15;
 		rc = gfx_puttext(font, &pos, &fmt, "The quick brown fox jumps over the lazy dog.");
 		if (rc != EOK)
@@ -642,16 +762,10 @@
 	}
 
-	gfx_font_close(font);
-	gfx_typeface_destroy(tface);
 	return EOK;
 error:
-	if (font != NULL)
-		gfx_font_close(font);
-	if (tface != NULL)
-		gfx_typeface_destroy(tface);
 	return rc;
 }
 
-/** Run demo loop on a graphic context.
+/** Run clipping demo on a graphic context.
  *
  * @param gc Graphic context
@@ -659,31 +773,143 @@
  * @param h Height
  */
+static errno_t demo_clip(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
+{
+	gfx_bitmap_t *bitmap;
+	gfx_color_t *color;
+	gfx_bitmap_params_t params;
+	int i, j;
+	gfx_coord2_t offs;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	if (quit)
+		return EOK;
+
+	rc = demo_begin(gc, w, h, "Clipping demonstration");
+	if (rc != EOK)
+		return rc;
+
+	gfx_bitmap_params_init(&params);
+	params.rect.p0.x = 0;
+	params.rect.p0.y = 0;
+	params.rect.p1.x = 40;
+	params.rect.p1.y = 20;
+
+	rc = gfx_bitmap_create(gc, &params, NULL, &bitmap);
+	if (rc != EOK)
+		return rc;
+
+	rc = bitmap_moire(bitmap, 40, 20);
+	if (rc != EOK)
+		goto error;
+
+	for (j = 0; j < 10; j++) {
+		rect.p0.x = w / 8;
+		rect.p0.y = h / 8;
+		rect.p1.x = w * 7 / 8;
+		rect.p1.y = h * 3 / 8;
+
+		rc = gfx_set_clip_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+
+		rc = gfx_color_new_rgb_i16(rand() % 0x10000, rand() % 0x10000,
+		    rand() % 0x10000, &color);
+		if (rc != EOK)
+			return rc;
+
+		rc = gfx_set_color(gc, color);
+		if (rc != EOK)
+			return rc;
+
+		for (i = 0; i < 10; i++) {
+			rect.p0.x = rand() % (w - 1);
+			rect.p0.y = rand() % (h - 1);
+			rect.p1.x = rect.p0.x + rand() % (w - 1 - rect.p0.x);
+			rect.p1.y = rect.p0.y + rand() % (h - 1 - rect.p0.y);
+
+			rc = gfx_fill_rect(gc, &rect);
+			if (rc != EOK)
+				return rc;
+		}
+
+		gfx_color_delete(color);
+
+		rect.p0.x = w / 8;
+		rect.p0.y = h * 5 / 8;
+		rect.p1.x = w * 7 / 8;
+		rect.p1.y = h * 7 / 8;
+
+		rc = gfx_set_clip_rect(gc, &rect);
+		if (rc != EOK)
+			return rc;
+
+		for (i = 0; i < 10; i++) {
+			offs.x = rand() % (w - 40);
+			offs.y = rand() % (h - 20);
+
+			rc = gfx_bitmap_render(bitmap, NULL, &offs);
+			if (rc != EOK)
+				goto error;
+		}
+
+		fibril_usleep(500 * 1000);
+
+		if (quit)
+			break;
+	}
+
+	(void) gfx_set_clip_rect(gc, NULL);
+	gfx_bitmap_destroy(bitmap);
+	return EOK;
+error:
+	(void) gfx_set_clip_rect(gc, NULL);
+	gfx_bitmap_destroy(bitmap);
+	return rc;
+}
+
+/** Run demo loop on a graphic context.
+ *
+ * @param gc Graphic context
+ * @param w Width
+ * @param h Height
+ */
 static errno_t demo_loop(gfx_context_t *gc, gfx_coord_t w, gfx_coord_t h)
 {
 	errno_t rc;
+
+	(void) demo_font_init(gc, w, h);
 
 	while (!quit) {
 		rc = demo_rects(gc, w, h);
 		if (rc != EOK)
-			return rc;
+			goto error;
 
 		rc = demo_bitmap(gc, w, h);
 		if (rc != EOK)
-			return rc;
+			goto error;
 
 		rc = demo_bitmap2(gc, w, h);
 		if (rc != EOK)
-			return rc;
+			goto error;
 
 		rc = demo_bitmap_kc(gc, w, h);
 		if (rc != EOK)
-			return rc;
+			goto error;
 
 		rc = demo_text(gc, w, h);
 		if (rc != EOK)
-			return rc;
-	}
-
-	return EOK;
+			goto error;
+
+		rc = demo_clip(gc, w, h);
+		if (rc != EOK)
+			goto error;
+	}
+
+	demo_font_fini();
+	return EOK;
+error:
+	demo_font_fini();
+	return rc;
 }
 
@@ -866,5 +1092,5 @@
 static void print_syntax(void)
 {
-	printf("Syntax: gfxdemo [-d <display>] {canvas|console|display}\n");
+	printf("Syntax: gfxdemo [-d <display>] {console|display|ui}\n");
 }
 
Index: uspace/app/inet/inet.c
===================================================================
--- uspace/app/inet/inet.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/inet/inet.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 #include <errno.h>
 #include <inet/addr.h>
+#include <inet/eth_addr.h>
 #include <inet/inetcfg.h>
 #include <io/table.h>
@@ -340,4 +341,5 @@
 	inet_link_info_t linfo;
 	table_t *table = NULL;
+	eth_addr_str_t saddr;
 
 	size_t count;
@@ -368,10 +370,7 @@
 		}
 
-		table_printf(table, "%02x:%02x:%02x:%02x:%02x:%02x\t"
-		    "%s\t" "%zu\n",
-		    linfo.mac_addr[0], linfo.mac_addr[1],
-		    linfo.mac_addr[2], linfo.mac_addr[3],
-		    linfo.mac_addr[4], linfo.mac_addr[5],
-		    linfo.name, linfo.def_mtu);
+		eth_addr_format(&linfo.mac_addr, &saddr);
+		table_printf(table, "%s\t %s\t %zu\n", saddr.str, linfo.name,
+		    linfo.def_mtu);
 
 		free(linfo.name);
Index: uspace/app/inet/meson.build
===================================================================
--- uspace/app/inet/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/inet/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2012 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('inet.c')
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/init/init.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -272,4 +272,6 @@
 }
 
+#ifdef CONFIG_WINSYS
+
 static errno_t display_server(void)
 {
@@ -302,4 +304,6 @@
 	return retval;
 }
+
+#endif
 
 static void getterm(const char *svc, const char *app, bool msg)
@@ -468,4 +472,5 @@
 	init_sysvol();
 
+#ifdef CONFIG_WINSYS
 	if (!config_key_exists("console")) {
 		rc = display_server();
@@ -476,5 +481,5 @@
 		}
 	}
-
+#endif
 	rc = console(HID_INPUT, HID_OUTPUT);
 	if (rc == EOK) {
Index: uspace/app/lprint/meson.build
===================================================================
--- uspace/app/lprint/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/lprint/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'device' ]
 src = files('lprint.c')
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/mkbd/main.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -174,6 +174,6 @@
 	while (true) {
 		cons_event_t ev;
-		bool ok = console_get_event(con, &ev);
-		if (!ok) {
+		errno_t rc = console_get_event(con, &ev);
+		if (rc != EOK) {
 			printf("Connection with console broken: %s.\n",
 			    str_error(errno));
Index: uspace/app/modplay/modplay.c
===================================================================
--- uspace/app/modplay/modplay.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/modplay/modplay.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -174,6 +174,10 @@
 	while (true) {
 		timeout = 0;
-		if (console_get_event_timeout(con, &event, &timeout))
+		rc = console_get_event_timeout(con, &event, &timeout);
+		if (rc == EOK)
 			modplay_event(&event);
+		else if (rc != ETIMEOUT)
+			break;
+
 		if (quit)
 			break;
Index: uspace/app/netecho/meson.build
===================================================================
--- uspace/app/netecho/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/netecho/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2016 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('comm.c', 'netecho.c')
Index: uspace/app/netecho/netecho.c
===================================================================
--- uspace/app/netecho/netecho.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/netecho/netecho.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -121,4 +121,5 @@
 {
 	cons_event_t ev;
+	errno_t rc;
 
 	printf("Communication started. Press Ctrl-Q to quit.\n");
@@ -128,5 +129,8 @@
 	done = false;
 	while (!done) {
-		console_get_event(con, &ev);
+		rc = console_get_event(con, &ev);
+		if (rc != EOK)
+			break;
+
 		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS)
 			key_handle(&ev.ev.key);
Index: uspace/app/nterm/meson.build
===================================================================
--- uspace/app/nterm/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/nterm/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2012 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('conn.c', 'nterm.c')
Index: uspace/app/nterm/nterm.c
===================================================================
--- uspace/app/nterm/nterm.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/nterm/nterm.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -130,5 +130,8 @@
 	done = false;
 	while (!done) {
-		console_get_event(con, &ev);
+		rc = console_get_event(con, &ev);
+		if (rc != EOK)
+			break;
+
 		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS)
 			key_handle(&ev.ev.key);
Index: uspace/app/pci/meson.build
===================================================================
--- uspace/app/pci/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/pci/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'device' ]
 src = files('pci.c')
Index: uspace/app/ping/meson.build
===================================================================
--- uspace/app/ping/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/ping/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2012 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('ping.c')
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/ping/ping.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -196,6 +196,10 @@
 	while (true) {
 		cons_event_t ev;
-		if (!console_get_event(con, &ev))
-			break;
+		errno_t rc;
+		rc = console_get_event(con, &ev);
+		if (rc != EOK) {
+			ping_signal_received(RECEIVED_INTERRUPT);
+			break;
+		}
 
 		if ((ev.type == CEV_KEY) && (ev.ev.key.type == KEY_PRESS) &&
Index: uspace/app/sbi/src/rdata_t.h
===================================================================
--- uspace/app/sbi/src/rdata_t.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/sbi/src/rdata_t.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -137,5 +137,5 @@
 	vc_bool,
 
-	/** Character **/
+	/** Character */
 	vc_char,
 
